耗子 95155b8273
Some checks failed
Generate Checksums / checksums (push) Has been cancelled
feat: 规范systemd权限
2025-03-29 16:00:15 +08:00

191 lines
6.1 KiB (Stored with Git LFS)
Bash
Raw Permalink Blame History

This file contains ambiguous Unicode characters

This file contains Unicode characters that might be confused with other characters. If you think that this is intentional, you can safely ignore this warning. Use the Escape button to reveal them.

#!/bin/bash
export PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:$PATH
: '
Copyright (C) 2022 - now HaoZi Technology Co., Ltd.
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published
by the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.
You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <https://www.gnu.org/licenses/>.
'
source <(curl -f -s --connect-timeout 10 --retry 3 https://dl.cdn.haozi.net/panel/public.sh)
if [ $? -ne 0 ]; then
echo "下载 public.sh 失败,请检查网络或稍后重试。"
echo "Download public.sh failed, please check the network or try again later."
exit 1
fi
channel=${1}
version=${2}
postgresql_path="${setup_path}/server/postgresql"
j=$(calculate_j)
# 安装依赖
if [ ${OS} == "rhel" ]; then
dnf makecache -y
dnf groupinstall "Development Tools" -y
dnf install pkg-config make bison flex gettext zlib-devel readline-devel icu libicu libicu-devel libxml2-devel libxslt-devel openssl-devel systemd-devel -y
elif [ ${OS} == "debian" ] || [ ${OS} == "ubuntu" ]; then
apt-get update
apt-get install build-essential pkg-config make bison flex gettext zlib1g-dev libreadline-dev icu-devtools libicu-dev libxml2-dev libxslt-dev libssl-dev libsystemd-dev -y
else
error "不支持的操作系统"
fi
if [ "$?" != "0" ]; then
error "安装依赖软件失败"
fi
user_check=$(cat /etc/passwd | grep postgres)
if [ "${user_check}" == "" ]; then
groupadd postgres
useradd -g postgres postgres
fi
# 准备目录
rm -rf ${postgresql_path}
mkdir -p ${postgresql_path}
cd ${postgresql_path}
# 下载源码
wget --retry-connrefused --retry-on-host-error --retry-on-http-error=429,500,502,503,504 -t 10 -T 120 -O ${postgresql_path}/postgresql-${version}.7z ${download_url}/postgresql/postgresql-${version}.7z
wget --retry-connrefused --retry-on-host-error --retry-on-http-error=429,500,502,503,504 -t 10 -T 120 -O ${postgresql_path}/postgresql-${version}.7z.sha256 ${download_url}/postgresql/postgresql-${version}.7z.sha256
if ! sha256sum --status -c postgresql-${version}.7z.sha256; then
rm -rf ${postgresql_path}
error "PostgreSQL 校验失败"
fi
7z x postgresql-${version}.7z
rm -f postgresql-${version}.7z
rm -f postgresql-${version}.7z.sha256
mv postgresql-${version} src
chmod -R 700 src
# 编译
cd src
./configure --prefix=${postgresql_path} --enable-nls='zh_CN en' --with-icu --with-ssl=openssl --with-systemd --with-libxml --with-libxslt
if [ "$?" != "0" ]; then
rm -rf ${postgresql_path}
error "PostgreSQL 编译初始化失败"
fi
make "-j${j}"
if [ "$?" != "0" ]; then
rm -rf ${postgresql_path}
error "PostgreSQL 编译失败"
fi
make install
if [ "$?" != "0" ]; then
rm -rf ${postgresql_path}
error "PostgreSQL 安装失败"
fi
cd ${postgresql_path}
rm -rf ${postgresql_path}/src
# 配置
mkdir -p ${postgresql_path}/data
mkdir -p ${postgresql_path}/logs
chown -R postgres:postgres ${postgresql_path}
chmod -R 700 ${postgresql_path}
# 软链接
ln -sf ${postgresql_path}/bin/* /usr/bin/
mkdir -p /home/postgres
cd /home/postgres
if [ -f /home/postgres/.bash_profile ]; then
echo "export PGHOME=${postgresql_path}" >>/home/postgres/.bash_profile
echo "export PGDATA=${postgresql_path}/data" >>/home/postgres/.bash_profile
echo "export PATH=${postgresql_path}/bin:\$PATH " >>/home/postgres/.bash_profile
echo "MANPATH=$PGHOME/share/man:$MANPATH" >>/home/postgres/.bash_profile
echo "LD_LIBRARY_PATH=$PGHOME/lib:$LD_LIBRARY_PATH" >>/home/postgres/.bash_profile
source /home/postgres/.bash_profile
fi
if [ -f /home/postgres/.profile ]; then
echo "export PGHOME=${postgresql_path}" >>/home/postgres/.profile
echo "export PGDATA=${postgresql_path}/data" >>/home/postgres/.profile
echo "export PATH=${postgresql_path}/bin:\$PATH " >>/home/postgres/.profile
echo "MANPATH=$PGHOME/share/man:$MANPATH" >>/home/postgres/.profile
echo "LD_LIBRARY_PATH=$PGHOME/lib:$LD_LIBRARY_PATH" >>/home/postgres/.profile
source /home/postgres/.profile
fi
# 初始化
su - postgres -c "${postgresql_path}/bin/initdb -D ${postgresql_path}/data"
if [ "$?" != "0" ]; then
rm -rf ${postgresql_path}
error "PostgreSQL 初始化失败"
fi
# 配置慢查询日志
cat >>${postgresql_path}/data/postgresql.conf <<EOF
logging_collector = on
log_destination = 'stderr'
log_directory = '${postgresql_path}/logs'
log_filename = 'postgresql-%Y-%m-%d.log'
log_statement = all
log_min_duration_statement = 5000
EOF
# 配置认证
cat >>${postgresql_path}/data/pg_hba.conf <<EOF
host all all all scram-sha-256
EOF
# 写入服务
cat >/etc/systemd/system/postgresql.service <<EOF
[Unit]
Description=PostgreSQL database server
Documentation=man:postgres(1)
After=network-online.target
Wants=network-online.target
[Service]
Type=notify
User=postgres
ExecStart=${postgresql_path}/bin/postgres -D ${postgresql_path}/data
ExecReload=/bin/kill -HUP \$MAINPID
KillMode=mixed
KillSignal=SIGINT
TimeoutSec=infinity
LimitNOFILE=500000
Restart=on-failure
RestartSec=5s
[Install]
WantedBy=multi-user.target
EOF
chmod 644 /etc/systemd/system/postgresql.service
# 在 /etc/systemd/logind.conf 设置 RemoveIPC=no否则会删除 /dev/shm 下的共享内存文件
check=$(cat /etc/systemd/logind.conf | grep '^RemoveIPC=no.*$')
if [ "${check}" == "" ]; then
echo "RemoveIPC=no" >>/etc/systemd/logind.conf
systemctl restart systemd-logind
fi
# 启动服务
systemctl daemon-reload
systemctl enable --now postgresql
if [ "$?" != "0" ]; then
error "启动失败"
fi
panel-cli app write postgresql ${channel} ${version}
panel-cli database add-server --type=postgresql --name=local_postgresql --host=127.0.0.1 --port=5432
echo -e $HR
echo "安装完成"
echo -e $HR